% Function approximation
% The given function y=f(x)
clc; clear all; close all;
% Training data: input patterns and output patterns
x=-1:0.1:1;
y=[-0.960 -0.577 -0.073 0.377 0.641 0.660 0.461...
    0.134 -0.201 -0.434 -0.5 -0.393 -0.165 0.099...
    0.307 0.396 0.345 0.182 -0.031 -0.219 -0.320];
% Create a NN and initialize weights
net=newff(minmax(x),[20 1],{'tansig','purelin'},'traingdx'); 
% Training functions: traingd, traingdm, traingda, traingdx
% output of NN with initial weights
ycap1=sim(net,x);
figure(1);
plot(x,ycap1,'-',x,y,'o');
% Train the NN
net.trainparam.goal=0.005;
net.trainparam.epochs=500;
net.trainparam.show=50;
net.trainparam.lr=0.01;
[net,tr]=train(net,x,y);
% Output of NN
% Generalization : input vector is different 
% from the one used for training
figure(2)
x2=-1:0.01:1;
ycap2=sim(net,x2);
plot(x2,ycap2,'-',x,y,'o');
% Weights and Biases of the trained network
w=net.IW{1,1}
bw=net.b{1}
v=net.LW{2,1}
bv=net.b{2}