% NN process control
clc; clear all; close all;
% Process model 
T=30; Y0=25;
alpha=1.00151e-4; beta=8.67973e-3;
F=exp(-alpha*T); g=beta*(1-F)/alpha;
y(1)=0;
% Generation of training data
% Input is a train of pulses of random height between 
% 0 and 5 & random width between 0 and 10
s=0;
for j=1:10
    width(j)=rand*10;
    height(j)=rand*5;
    for k=1:10
        if ( k<=width(j))
            u(k+s)=height(j);
        else
            u(k+s)=0;
        end
        y(k+s+1)=F*y(k+s)+g*u(k+s)/(1+exp(0.5*y(k+s)-40))+(1-F)*Y0;
    end
    s=s+10;
end
NNinput=[y(2:101);y(1:100)];
NNoutput=[u(1:100)];
% Preprocessing of data
NNinput=NNinput/80;
NNoutput=NNoutput/5;
% Creation and training of NN
net=newff(minmax(NNinput),[5 1],{'logsig','purelin'});
[net tr]=train(net,NNinput,NNoutput);
% Weights and biases of trained NN
w1=net.IW{1,1}
b1=net.b{1}
w2=net.LW{2,1}
b2=net.b{2}
% Testing the NN
ucap=sim(net,NNinput)*5;
figure(1)
k=1:100;
plot(k,ucap,'r',k,u);
% Reference trajectory
for i=1:90
    if (i<=30)
        yr(i)=35;
    elseif (i<=60)
        yr(i)=55;
    else
        yr(i)=75;
    end
end
% Command-line simulation
y_sim(1)=Y0;
for k=1:89
    inp=[yr(k+1);y_sim(k)]/80;
    u_sim(k)=sim(net,inp)*5;
    y_sim(k+1)=F*y_sim(k)+g*u_sim(k)...
    /(1+exp(0.5*y_sim(k)-40))+(1-F)*Y0;
end
k=1:90;
figure(2)
plot(k,yr,k,y_sim,'r')
% Open SimulinkFigPB10; before creating this Simulink file; the command 
% gensim(net,T) was executed in MATLAB command window.