% Function approximation
clc; clear all; close all;
% Training data
trainx=0:0.2:4;
trainy=exp(-trainx).*sin(3*trainx);
figure(1)
plot(trainx,trainy);
% Testing data
testx=0:0.01:4;
testy=exp(-testx).*sin(3*testx);
figure(2)
plot(testx,testy);
% Creating a feedforward NN
net=newff(minmax(trainx),[7 1],{'tansig','tansig'},'trainlm');
% Train the NN
net.trainparam.goal=0.01;
net.trainparam.epochs=500;
net.trainparam.show=50;
[net,tr]=train(net,trainx,trainy);
% Output of trained NN
ycap2=sim(net,trainx);
figure(3)
plot(trainx,ycap2,'-',trainx,trainy,'o');
% Generalization : Testing NN with unseen input
ycap3=sim(net,testx);
figure(4)
plot(testx,ycap3,'-',testx,testy,'o');
% Weights and Biases of the trained network
w=net.IW{1,1}
bw=net.b{1}
v=net.LW{2,1}
bv=net.b{2}