% System Identification
clc; clear all; close all;
% Define initial values
y(1)=0;y(2)=0;
% Create 500 random-value data from input space [-2,2]
% obtain training patterns
N=500;
for k=2:N    
    f(k)=y(k)*(y(k-1)+2)*(y(k)+2.5)...
    /(8.5+y(k)*y(k)+y(k-1)*y(k-1));
    u(k)=(rand-0.5)*4;
    y(k+1)=f(k)+u(k);    
end
for k=1:(N-1)
    input(1,k)=y(k+1);
    input(2,k)=y(k);
    target(k)=f(k+1);
end
% Build the feedforward NN
net=newff(minmax(input),[10 1],{'tansig','purelin'});
net.trainparam.goal=0.005;
net.trainparam.lr=0.1;
% Train the NN
net=train(net,input,target);
% Testing the NN
for k=1:200 u1(k)=2*cos(2*pi*k/100); end
for k=201:500 u1(k)=1.2*sin(2*pi*k/20); end
yp(1)=0; yp(2)=0; ycap(1)=0; ycap(2)=0;
% yp- from direct calculation
% ycap - NN Simulation
for k=2:500    
    yp(k+1)=yp(k)*(yp(k-1)+2)*(yp(k)+2.5)...
    /(8.5+yp(k)*yp(k)+yp(k-1)*yp(k-1))+u1(k);
    ycap(k+1)=sim(net,[ycap(k);ycap(k-1)])+u1(k);
end
figure(1)
plot(1:501,yp,'r',1:501,ycap,'g');