% System Identification
clc; clear all; close all;
% Define initial values
x1(1)=0;x2(1)=0;y(1)=0;
% Training patterns of uniformly distributed noise sequence
% in the interval [-0.5,0.5]; 50 samples
for k=1:50 u(k)=(rand-0.5); end
% Finding actual system output for input u(k)
for k=1:49
    x1(k+1)=x2(k)/(x1(k)+4);
    temp=x1(k)+(1+x2(k))*u(k);
    x2(k+1)=tanh(temp);
    y(k+1)=2*x2(k+1);    
end
for k=1:(50-4)
    input(1,k)=y(k+3);
    input(2,k)=y(k+2);
    input(3,k)=y(k+1);
    input(4,k)=y(k);
    input(5,k)=u(k+3);
    input(6,k)=u(k+2);
    input(7,k)=u(k+1);
    input(8,k)=u(k);    
    target(k)=y(k+4);
end
% Build the Feedforward NN
net=newff(minmax(input),[2 1 1],{'tansig','tansig','purelin'});
% Train the NN
net.trainparam.goal=1e-5;
net.trainparam.epochs=1000;
net=train(net,input,target);
% Output of the trained NN
ytraincap=sim(net,input);
ytraincap=[0 0 0 0 ytraincap];
y(1)=0;y(2)=0;y(3)=0;y(4)=0;
figure(1)
plot(1:50,y,1:50,ytraincap,'r');
% Generate testing input for the NN
for k=1:50
    u1(k)=0.2*square(2*pi*0.04*k);
end
yp(1)=0;x1(1)=0;x2(1)=0;
for k=1:49
    x1(k+1)=x2(k)/(x1(k)+4);    
    temp=x1(k)+(1+x2(k))*u1(k);
    x2(k+1)=tanh(temp);
    yp(k+1)=2*x2(k+1);    
end
yp(2)=0;yp(3)=0;yp(4)=0;
% Testing the NN
% yp - output of the Nonlinear system
% ycap - output of the trained NN
ycap(1)=0; ycap(2)=0; ycap(3)=0;ycap(4)=0;
for k=4:49
    temp=[ycap(k);ycap(k-1);ycap(k-2);ycap(k-3);...
    u1(k);u1(k-1);u1(k-2);u1(k-3)];
    ycap(k+1)=sim(net,temp);
end
figure(2)
plot(1:50,u1,1:50,yp,1:50,ycap,'r');



