% System Identification
clc; clear all; close all;
% Training-input generation 
N=50;
u=idinput(N,'prbs');
y(1)=0;y(2)=0;
for k=3:N
    y(k)=1.615*y(k-1)-0.779*y(k-2)+0.08508*u(k-1)+0.07824*u(k-2);
end
% Adding Gaussian white noise to system output 
yn=awgn(y,25);
% y - system output
% yn - system output corrupted by noise
figure(1)
plot(1:N,y,1:N,yn,'r');    
for k=1:(N-2)
    input(1,k)=yn(k+1);
    input(2,k)=yn(k);
    input(3,k)=u(k+1);
    input(4,k)=u(k);  
    target(k)=yn(k+2);
end
% Creating a feedforward NN
net=newff(minmax(input),[1],{'purelin'});
net.trainparam.goal=1e-3;
% Train the NN
net=train(net,input,target);
% Trained NN's weights and biases
net.IW{1}
net.b{1}
% Output of trained NN for training input
ytraincap=sim(net,input);
ytraincap=[0 0 ytraincap];
figure(2)
plot(1:N,ytraincap,'r',1:N,y);
% Testing-input generation (step)
u1=ones(1,N);
y1(1)=0;y1(2)=0;
for k=3:N
    y1(k)=1.615*y1(k-1)-0.779*y1(k-2)+0.08508*u1(k-1)+0.07824*u1(k-2);
end
for k=1:(N-2)
    input1(1,k)=y1(k+1);
    input1(2,k)=y1(k);
    input1(3,k)=u1(k+1);
    input1(4,k)=u1(k);  
    target1(k)=y1(k+2);
end
% Testing NN
ycap=sim(net,input1);
ycap=[0 0 ycap];
% y1 - system output
% ycap - NN output 
% u1 - test input
figure(3)
plot(1:N,u1,1:N,ycap,'r',1:N,y1,'g');